/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/* Ver referencias aqui http://bitingenieria.com.ar/doc/ifu/IFUniversal_TLB/IDriver.html*/

package ifu.demo;

import ifu.wsh.Baudio;
import ifu.wsh.ClassFactory;
import ifu.wsh.CondicionesIVA;
import ifu.wsh.ICierreZTotales;
import ifu.wsh.IDriver;
import ifu.wsh.ModeloPrn;
import ifu.wsh.ResponsabilidadIVA;
import ifu.wsh.TipoDeDocumento;
import ifu.wsh.TipoDeComprobante;
import ifu.wsh.TipoImpuestoInterno;
import ifu.wsh.TiposPago;
import ifu.wsh.UnidadesMedida;
import javax.swing.JOptionPane;

/**
 *
 * @author amiranda
 */
public class MainFrame extends javax.swing.JFrame {

    private static final int cPUERTO = 31;
    private static final ModeloPrn cMODELO = ModeloPrn.modHasarPT1000F;

    /**
     * Creates new form MainFrame
     */
    public MainFrame() {
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jButton4 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jButton1.setText("Factura B");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jButton2.setText("Cierre Z");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jButton3.setText("Factura A");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        jButton4.setText("Nota de Credito B");
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(34, 34, 34)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jButton4)
                    .addComponent(jButton3)
                    .addComponent(jButton1)
                    .addComponent(jButton2))
                .addContainerGap(249, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(52, 52, 52)
                .addComponent(jButton2)
                .addGap(18, 18, 18)
                .addComponent(jButton1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jButton3)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jButton4)
                .addContainerGap(116, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void printReceipt(boolean printClientData, TipoDeComprobante tipoComprobante,
            boolean esNotaDeCredito) {
        IDriver fiscal = ClassFactory.createDriver();

        try {

            fiscal.modelo(cMODELO);
            fiscal.puerto(cPUERTO);
            fiscal.baudios(Baudio.bd9600);

            if (!fiscal.inicializar()) {
                throw new Exception(fiscal.errorDesc(), null);
            }

            fiscal.cancelarComprobante();

            if (printClientData) {
                if (!fiscal.datosCliente("Abel Miranda", TipoDeDocumento.tdCUIT, "20939802593",
                        ResponsabilidadIVA.riResponsableInscripto, "Haefreingue, 1686, Moron")) {
                    throw new Exception(fiscal.errorDesc());
                }
            }
            
            if (esNotaDeCredito){
                if (!fiscal.documentoDeReferencia2g(TipoDeComprobante.tcFactura_B, "0001-00000001")) {
                    throw new Exception(fiscal.errorDesc(), null);
                }
            }

            if (!fiscal.abrirComprobante(tipoComprobante)) {
                throw new Exception(fiscal.errorDesc(), null);
            }

            if (!fiscal.imprimirItem2g("Item 1", 1, 0.1, 21, 0, CondicionesIVA.Gravado,
                    TipoImpuestoInterno.tiFijo, 1, "7790001001054", "", UnidadesMedida.Unidad)) {
                throw new Exception(fiscal.errorDesc(), null);
            }

            if (!fiscal.imprimirDescuentoGeneral("Descuento General", 0.01)) {
                throw new Exception(fiscal.errorDesc(), null);
            }

            if (!fiscal.imprimirPago2g("Efectivo", 5, "", TiposPago.Efectivo, 1, "", "")) {
                throw new Exception(fiscal.errorDesc(), null);
            }

            fiscal.cerrarComprobante();

            fiscal.finalizar();

            JOptionPane.showMessageDialog(this,
                    "Comprobante impreso exitosamente.",
                    "IFU Demo",
                    JOptionPane.PLAIN_MESSAGE);

        } catch (Exception e) {
            JOptionPane.showMessageDialog(this,
                    e.getMessage(),
                    "IFU Demo",
                    JOptionPane.PLAIN_MESSAGE);

        }

    }

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed

        printReceipt(false, TipoDeComprobante.tcFactura_B, false);


    }//GEN-LAST:event_jButton1ActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        IDriver fiscal = ClassFactory.createDriver();

        try {

            fiscal.modelo(cMODELO);
            fiscal.puerto(cPUERTO);
            fiscal.baudios(Baudio.bd9600);

            if (!fiscal.inicializar()) {
                throw new Exception(fiscal.errorDesc(), null);
            }

            fiscal.cancelarComprobante();

            if (!fiscal.cierreZ()) {
                throw new Exception(fiscal.errorDesc(), null);
            }
            
            ICierreZTotales totales = fiscal.cierreZTotales();

            fiscal.finalizar();

            JOptionPane.showMessageDialog(this,
                    "Cierre realizado exitosamente.",
                    "IFU Demo",
                    JOptionPane.PLAIN_MESSAGE);

        } catch (Exception e) {
            JOptionPane.showMessageDialog(this,
                    e.getMessage(),
                    "IFU Demo",
                    JOptionPane.PLAIN_MESSAGE);

        }
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        printReceipt(true, TipoDeComprobante.tcFactura_A, false);
    }//GEN-LAST:event_jButton3ActionPerformed

    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
        printReceipt(true, TipoDeComprobante.tcNota_Credito_B, true);
    }//GEN-LAST:event_jButton4ActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(MainFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(MainFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(MainFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(MainFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new MainFrame().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    // End of variables declaration//GEN-END:variables
}
